#ifndef MSP_DATAFILE_BUILTINSOURCE_H_
#define MSP_DATAFILE_BUILTINSOURCE_H_

#include "collectionsource.h"

namespace Msp {
namespace DataFile {

class BuiltinSource: public CollectionSource
{
private:
	struct Object
	{
		const char *data = nullptr;
		unsigned size = 0;

		Object() = default;
		Object(const char *, unsigned);
	};

	std::map<std::string, Object> objects;

public:
	void add_object(const std::string &, const char *, unsigned);
	void add_object(const std::string &, const char *);

	bool is_loadable(const CollectionItemTypeBase &, const std::string &) const override;
	NameList get_names(const CollectionItemTypeBase &) const override;
	void load(Collection &, const CollectionItemTypeBase &, const std::string &) const override;
	IO::Seekable *open(const std::string &) const override;
};

} // namespace DataFile
} // namespace Msp

#endif
