#ifndef MSP_DATAFILE_DIRECTORYSOURCE_H_
#define MSP_DATAFILE_DIRECTORYSOURCE_H_

#include <msp/fs/path.h>
#include "collectionsource.h"

namespace Msp {
namespace DataFile {

/**
A source that load items from files in a directory.
*/
class DirectorySource: public CollectionSource
{
private:
	typedef std::map<std::string, FS::Path> ObjectMap;

	ObjectMap objects;

public:
	void add_directory(const FS::Path &, bool = true);

	bool is_loadable(const CollectionItemTypeBase &, const std::string &) const override;
	NameList get_names(const CollectionItemTypeBase &) const override;
	void load(Collection &, const CollectionItemTypeBase &, const std::string &) const override;
	IO::Seekable *open(const std::string &) const override;

	bool lookup_file(const std::string &, FS::Path &) const;
};

} // namespace DataFile
} // namespace Msp

#endif
