#include <msp/io/zlibcompressed.h>
#include "input.h"

namespace Msp {
namespace DataFile {

Input::Input(IO::Base &i):
	in(&i)
{ }

Input::~Input()
{
	delete compressed;
}

void Input::set_decompress()
{
	compressed = new IO::ZlibCompressed(*in, IO::M_READ);
	in = compressed;
}

int Input::get()
{
	int c = next;
	next = -1;
	if(c<0)
		c = in->get();
	
	if(c=='\n')
		++line;

	return c;
}

int Input::peek()
{
	if(next<0)
		next = in->get();
	return next;
}

Input::operator bool() const
{
	return next>=0 || !in->eof();
}

} // namespace DataFile
} // namespace Msp
