#include <msp/io/zlibcompressed.h>
#include "output.h"

using namespace std;

namespace Msp {
namespace DataFile {

Output::Output(IO::Base &o):
	out(&o)
{ }

Output::~Output()
{
	delete compressed;
}

void Output::set_compressed()
{
	compressed = new IO::ZlibCompressed(*out, IO::M_WRITE);
	out = compressed;
}

unsigned Output::put(char c)
{
	return out->put(c);
}

unsigned Output::write(const string &s)
{
	return out->write(s);
}

} // namespace DataFile
} // namespace Msp
