#ifndef MSP_DATAFILE_TEXTPARSER_H_
#define MSP_DATAFILE_TEXTPARSER_H_

#include "parsermode.h"

namespace Msp {
namespace DataFile {

struct Token;

class TextParser: public ParserMode
{
public:
	TextParser(Input &, const std::string &);

	Statement parse() override;
protected:
	Statement parse_statement(const Token *);
	Token parse_token();
	bool is_delimiter(int);
	bool isodigit(int);
	static std::string base64_decode(const std::string &);
};

} // namespace DataFile
} // namespace Msp

#endif
