#ifndef MSP_DATAFILE_TOKEN_H_
#define MSP_DATAFILE_TOKEN_H_

#include <string>

namespace Msp {
namespace DataFile {

struct Token
{
	enum Type
	{
		INTEGER,
		FLOAT,
		STRING,
		IDENTIFIER,
		SPECIAL
	};

	Type type = SPECIAL;
	std::string str;

	Token() = default;
	Token(Type t, const std::string &s): type(t), str(s) { }
};

} // namespace DataFile
} // namespace Msp

#endif
